/*
GLSLF̂̕`
*/
#include <fstream>
#include <string>
#include <iostream>
#include <GL/glew.h>
#include <GL/glut.h>
using namespace std;

int WindowPositionX = 200;  //EBhEʒuXW
int WindowPositionY = 100;  //EBhEʒuYW
int WindowWidth  = 512;     //EBhE̕
int WindowHeight = 512;     //EBhE̍
char WindowTitle[] = "E̎n܂";	//EBhẼ^Cg

//----------------------------------------------------
// VF[_RpC֘A
//----------------------------------------------------
GLuint shaderProgram;       //VF[_vO
/* _obt@IuWFNgID */
#define VERTEX  1
#define FRAGMENT  2

GLuint getShader(const char *file, int type)
{
	GLuint shader;
  if(type == VERTEX)        shader = glCreateShader(GL_VERTEX_SHADER);
  else if(type == FRAGMENT) shader = glCreateShader(GL_FRAGMENT_SHADER);

	ifstream ifs(file);
	istreambuf_iterator<char> vdataBegin(ifs);
	istreambuf_iterator<char> vdataEnd;
	string filedata(vdataBegin,vdataEnd);
	const char *vfile = filedata.c_str();

	glShaderSource(shader, 1, &vfile, NULL);	//\[XR[hVF[_IuWFNgɕϊ
	glCompileShader(shader);                  //RpC

	return shader;
}

void initShaders()
{
  //glew̏
  GLenum err = glewInit();
  if (err != GLEW_OK)
  {
	  printf("Error: %s\n", glewGetErrorString(err));
  }
	//VF[_[̓ǂݍ݂ƃRpC
  GLuint vertexShader   = getShader("../../test.vert", VERTEX);
  GLuint fragmentShader = getShader("../../test.frag", FRAGMENT);

  shaderProgram = glCreateProgram();  // vOIuWFNg̍쐬 

  glAttachShader(shaderProgram, vertexShader);
  glAttachShader(shaderProgram, fragmentShader);

  glLinkProgram(shaderProgram);
}

GLuint vertexPositionID, vertexColorID, vertexIndexID;
void initBuffers(){
	/////////////////////////////////////////////
	// _W̔z
	/////////////////////////////////////////////
	GLfloat vertices[24][3] = { 
		{-1.0, -1.0,  1.0}, { 1.0, -1.0,  1.0}, { 1.0,  1.0,  1.0}, {-1.0,  1.0,  1.0}, // A
		{-1.0, -1.0, -1.0}, {-1.0,  1.0, -1.0}, { 1.0,  1.0, -1.0}, { 1.0, -1.0, -1.0}, // B
		{-1.0,  1.0, -1.0}, {-1.0,  1.0,  1.0}, { 1.0,  1.0,  1.0}, { 1.0,  1.0, -1.0}, // C
		{-1.0, -1.0, -1.0}, { 1.0, -1.0, -1.0}, { 1.0, -1.0,  1.0}, {-1.0, -1.0,  1.0}, // D
		{ 1.0, -1.0, -1.0}, { 1.0,  1.0, -1.0}, { 1.0,  1.0,  1.0}, { 1.0, -1.0,  1.0}, // E
		{-1.0, -1.0, -1.0}, {-1.0, -1.0,  1.0}, {-1.0,  1.0,  1.0}, {-1.0,  1.0, -1.0}  // F
	};
	/////////////////////////////////////////////
	// _F̔z
	/////////////////////////////////////////////
	GLfloat colors[24][4] = {
		{1.0, 0.0, 0.0, 1.0}, {1.0, 1.0, 0.0, 1.0}, {1.0, 1.0, 1.0, 1.0}, {1.0, 0.0, 1.0, 1.0}, // A
		{0.0, 0.0, 0.0, 1.0}, {0.0, 0.0, 1.0, 1.0}, {0.0, 1.0, 1.0, 1.0}, {0.0, 1.0, 0.0, 1.0}, // B
		{0.0, 0.0, 1.0, 1.0}, {1.0, 0.0, 1.0, 1.0}, {1.0, 1.0, 1.0, 1.0}, {0.0, 1.0, 1.0, 1.0}, // C
		{0.0, 0.0, 0.0, 1.0}, {0.0, 1.0, 0.0, 1.0}, {1.0, 1.0, 0.0, 1.0}, {1.0, 0.0, 0.0, 1.0}, // D
		{0.0, 1.0, 0.0, 1.0}, {0.0, 1.0, 1.0, 1.0}, {1.0, 1.0, 1.0, 1.0}, {1.0, 1.0, 0.0, 1.0}, // E
		{0.0, 0.0, 0.0, 1.0}, {1.0, 0.0, 0.0, 1.0}, {1.0, 0.0, 1.0, 1.0}, {0.0, 0.0, 1.0, 1.0}  // F
	};
	/////////////////////////////////////////////
	// CfbNX̔z
	/////////////////////////////////////////////
	GLuint indices[36] = {
		0, 1, 2,      0,  2, 3,    // A
		4, 5, 6,      4,  6, 7,    // B
		8, 9, 10,     8,  10, 11,  // C
		12, 13, 14,   12, 14, 15,  // D
		16, 17, 18,   16, 18, 19,  // E
		20, 21, 22,   20, 22, 23   // F
	};

  glGenBuffers(1, &vertexPositionID); 
	glBindBuffer(GL_ARRAY_BUFFER, vertexPositionID);
  glBufferData(GL_ARRAY_BUFFER, sizeof (vertices), vertices , GL_STATIC_DRAW);

  glGenBuffers(1, &vertexColorID); 
	glBindBuffer(GL_ARRAY_BUFFER, vertexColorID);
  glBufferData(GL_ARRAY_BUFFER, sizeof (colors), colors , GL_STATIC_DRAW);

	glGenBuffers(1, &vertexIndexID);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertexIndexID);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(indices), indices, GL_STATIC_DRAW);
}

//----------------------------------------------------
// ݒ̊֐
//----------------------------------------------------
void initialize(void){
	glClearColor(0.0, 0.0, 0.0, 1.0);              //J[obt@[̏l̎wiwiFj
	glEnable( GL_DEPTH_TEST );                     //fvXobt@[L
	glViewport( 0, 0, WindowWidth, WindowHeight ); //r[|[g̐ݒ

	glMatrixMode( GL_PROJECTION );  //s񃂁[hvWFNVsɎw
	glLoadIdentity();               //Jgs̏

	gluPerspective(30.0, (double)WindowWidth/(double)WindowHeight, 0.1, 1000.0); //e@̎̐gluPerspactive(th, w/h, near, far);


	glMatrixMode( GL_MODELVIEW ); //s񃂁[hfr[sɎw
	glLoadIdentity();             //Jgs̏
	/////////////////////////////////////////////
	// _̐ݒ
	/////////////////////////////////////////////
	gluLookAt(             // _̐ݒ
		   5.0, 5.0, 5.0,    // _̈ʒux,y,z;
		   0.0, 0.0, 0.0,    // E̒Sʒu̎QƓ_Wx,y,z
		   0.0, 0.0, 1.0);   // Ȅ̃xNgx,y,z
}
//--------------------------------------------------------
// AChɌĂяo֐
//--------------------------------------------------------
void idle(){
 glutPostRedisplay(); //glutDisplayFunc()Ps
}
//----------------------------------------------------
// `֐
//----------------------------------------------------
int step = 0;
void draw(){
	step++;
	glPushMatrix();
		glTranslatef(0.0, 0.0, 0.0);     //sړ
		glRotatef(step , 0.0, 0.0, 1.0);  //]
		glEnableClientState(GL_VERTEX_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexPositionID);
		glVertexPointer(3, GL_FLOAT, 0, 0);

		glEnableClientState(GL_COLOR_ARRAY);
		glBindBuffer(GL_ARRAY_BUFFER, vertexColorID);
		glColorPointer(4, GL_FLOAT, 0, 0);

		glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, vertexIndexID);
		glDrawElements(GL_TRIANGLES, 36,	GL_UNSIGNED_INT, 0);
	glPopMatrix();
}

void display(void){
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //obt@̏

  glUseProgram(shaderProgram); //w肵VF[_𗘗p
	draw();
	glUseProgram(0);             //w肵VF[_̖

	glutSwapBuffers(); //glutInitDisplayMode(GLUT_DOUBLE)Ń_uobt@O𗘗p
}

//----------------------------------------------------
// C֐
//----------------------------------------------------
int main(int argc, char** argv){
	glutInit(&argc, argv);                                     //̏
	glutInitWindowPosition(WindowPositionX, WindowPositionY);  //EBhËʒu̎w
	glutInitWindowSize(WindowWidth, WindowHeight);             //EBhETCY̎w
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE); //fBXvC[h̎w
	glutCreateWindow(WindowTitle);                             //EBhE̍쐬
	glutDisplayFunc(display);                                  //`掞ɌĂяo֐w肷i֐Fdisplayj
	glutIdleFunc(idle);                                        //vOAChԎɌĂяo֐
  initShaders();
	initBuffers();
	initialize();                                              //ݒ̊֐Ăяo
	glutMainLoop();
 	glDeleteProgram(shaderProgram);
	return 0;
}
